#include <pspkernel.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <pspdisplay.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "systemctrl.h"

#include "ui.h"

#include "blit.h"

enum{
	TMENU_DUMMY,
	TMENU_FUNCTION,
	TMENU_FUNCTION_VALUE,
	TMENU_FUNCTION_EXIT,
	TMENU_SWITCH,
	TMENU_EXIT,
};

enum{
	FUNC_GET_STR,
	FUNC_CHANGE_VALUE
};

typedef struct
{
	char *path;
	int type;
	void *value;
	int draw_type;
}Menu_pack;

int menu_draw( const Menu_pack *menu_list, int menu_max);
int menu_setup(void);
int menu_ctrl( const Menu_pack *menu_list, int menu_max_cnt);

void init_clock();
void init_gamepath();
void *change_game_clock(int type, int dir );

void *connect_usb(int type, int dir );

void request_shutdown();
void request_suspend();
void request_reset_device();
void request_reset_vsh();
void request_pause();

u32 get_kernel_key();
u32 get_user_key();

u32 get_config(const char *index);
void load_config(const char *path);
