#include <pspkernel.h>
#include <pspsysmem_kernel.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *strtok_r(char *s1, const char *s2, char **s3);

#include "common.h"

#define printf(...)	{}

struct ResourceConfig {
	const char *path;
	u32 value;
};

struct ConfigPack {
	const char *str;
	const int type;
	const struct ResourceConfig *resource;
	u32 value_int;
};

static struct ResourceConfig key_config[] = {
	{"PSP_CTRL_SELECT"	, PSP_CTRL_SELECT	},
	{"PSP_CTRL_START"	, PSP_CTRL_START	},
	{"PSP_CTRL_UP"		, PSP_CTRL_UP		},
	{"PSP_CTRL_RIGHT"	, PSP_CTRL_RIGHT	},
	{"PSP_CTRL_DOWN"	, PSP_CTRL_DOWN		},
	{"PSP_CTRL_LEFT"	, PSP_CTRL_LEFT		},
	{"PSP_CTRL_LTRIGGER", PSP_CTRL_LTRIGGER	},
	{"PSP_CTRL_RTRIGGER", PSP_CTRL_RTRIGGER	},
	{"PSP_CTRL_TRIANGLE", PSP_CTRL_TRIANGLE	},
	{"PSP_CTRL_CIRCLE"	, PSP_CTRL_CIRCLE	},
	{"PSP_CTRL_CROSS"	, PSP_CTRL_CROSS	},
	{"PSP_CTRL_SQUARE"	, PSP_CTRL_SQUARE	},
	{"PSP_CTRL_HOME"	, PSP_CTRL_HOME		},
	{"PSP_CTRL_NOTE"	, PSP_CTRL_NOTE		},
	{"PSP_CTRL_SCREEN"	, PSP_CTRL_SCREEN	},
	{"PSP_CTRL_VOLUP"	, PSP_CTRL_VOLUP	},
	{"PSP_CTRL_VOLDOWN"	, PSP_CTRL_VOLDOWN	},
	{ NULL				, 0					},
};

struct ConfigPack config_pack[] = {
	{"KEY_CONFIG"		, 0, key_config , PSP_CTRL_SELECT | PSP_CTRL_START },
	{"TITLE_BACK_COLOR"	, 1, NULL		, 0xFF00B000 },
	{"MENU_BACK_COLOR"	, 1, NULL		, 0xFF0000B0 },
	{"CURSOR_BACK_COLOR", 1, NULL		, 0xFFFF8080 },
};

void load_config(const char *dir)
{
	char conf_buff[1024];
	char path[256];

	strcpy( path, dir);
	strcat( path, "GameMenuConfig.txt");

	printf("enter \n");

	int fd = sceIoOpen( path, PSP_O_RDONLY, 0777);
	if( fd >= 0 )
	{
		memset( conf_buff , 0, 1024);
		sceIoRead(fd , conf_buff, 1024);
		sceIoClose(fd);

		printf("load \n");

		char *token;
		char *saveptr1 = NULL;

		for(token = strtok_r( conf_buff , "\r\n", &saveptr1);
			token != NULL;
			token = strtok_r(NULL, "\r\n", &saveptr1)) 
		{
			if( token[0] != '#')
			{
				printf("%s \n", token );
				int i,j;
				for(i=0;i<(sizeof(config_pack)/sizeof(struct ConfigPack));i++)
				{
					if( strstr( token, config_pack[i].str ) == token )
					{
						int len = strlen( config_pack[i].str );
						if( token[len] == ' ' || token[len] == '=' )
						{
							if( config_pack[i].type == 0 )
							{
								const struct ResourceConfig *config = config_pack[i].resource;
								u32 value = 0;
								for(j=0; config[j].path != NULL;j++)
								{
									if( strstr( token, config[j].path ) != NULL )
									{
										printf("found %s \n", config[j].path );
										value |= config[j].value;
									}
								}

								config_pack[i].value_int = value;
							}
							else if(config_pack[i].type == 1)
							{
								char *p = strstr( token, "0x" );
								if( p )
								{
									//0xFFFF8080
									p[10] = 0;
									int value = strtol(p , NULL, 16);
									if( value != 0)
										config_pack[i].value_int = (u32)value;
								}

							}

							break;
						}
					}
				}
			}
		}
	}
}

u32 get_config(const char *index)
{
	int i;
	for(i=0;i<(sizeof(config_pack)/sizeof(struct ConfigPack));i++)
	{
		if( strcmp( index, config_pack[i].str ) == 0 )
		{
			printf("found %s :ret = 0x%08X \n", config_pack[i].str, config_pack[i].value_int );
			return config_pack[i].value_int;
		}
	}

	return 0;
}