/*
	PSP VSH MENU controll
	based Booster's vshex
*/

#include "common.h"

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//extern int pwidth;

/////////////////////////////////////////////////////////////////////////////
// draw strings
/////////////////////////////////////////////////////////////////////////////
char menu_title[] = "6.39 GAME MENU";

static const char * enable_disable[] ={
	"Enable",
	"Disable"
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
int menu_sel = 0;//TMENU_XMB_CLOCK;
u32 title_color = 0xFF00B000, menu_color =  0xFF0000B0, cursor_color = 0xFFFF8080;

/////////////////////////////////////////////////////////////////////////////
// draw menu 
/////////////////////////////////////////////////////////////////////////////
int menu_draw(const Menu_pack *menu_list, int menu_max)
{
	const char *msg;
	int i;
	void *(* surrent_get)();
	
	// show menu list
	blit_set_color(0xffffffff,title_color);
	blit_string( 0xB0 , 0x30 , menu_title );

	int y = (8)*8;
	for(i=0;i < menu_max;i++, y += 8)
	{
		blit_set_color( 0xffffffff , ( i== menu_sel)? cursor_color : menu_color );

		int draw_type = menu_list[i].draw_type;
		if( draw_type == 0 )
			blit_string( 0x88 , y , menu_list[i].path );
		else
			blit_string( draw_type, y , menu_list[i].path );

		switch( menu_list[i].type )
		{
		case TMENU_SWITCH:
			msg = (char *)(enable_disable[*(int*)menu_list[i].value]);
			blit_string( (0x11 * 8) + 128 , y ,msg);
			break;
		case TMENU_FUNCTION_VALUE:
			surrent_get = menu_list[i].value;
			msg = surrent_get(FUNC_GET_STR);
			blit_string( (0x11 * 8) + 128 , y ,msg);
			break;
		}
	}

	return 0;
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
int menu_ctrl( const Menu_pack *menu_list, int menu_max_cnt)
{
	int direction;
	u32 button_on = get_user_key();

	if( (button_on&PSP_CTRL_SELECT) ||
		(button_on&PSP_CTRL_HOME))
	{
		menu_sel = menu_max_cnt - 1;
		return 1;
	}

	// change menu select
	direction = 0;
	if(button_on&PSP_CTRL_DOWN) direction++;
	if(button_on&PSP_CTRL_UP) direction--;
	if( direction )
	{
		menu_sel = limit(menu_sel+direction,0, menu_max_cnt -1 );
	}

	// LEFT & RIGHT
	direction = -2;
	if(button_on&PSP_CTRL_LEFT)   direction = -1;
	if(button_on&(PSP_CTRL_CROSS|PSP_CTRL_CIRCLE)) direction = 0;
	if(button_on&PSP_CTRL_RIGHT)  direction = 1;
	if(direction>-2)
	{
		void (* func)();
		switch( menu_list[menu_sel].type )
		{
		case TMENU_FUNCTION:
			func = (void *)(menu_list[menu_sel].value);
			func();
			break;
		case TMENU_FUNCTION_VALUE:
			func = (void *)(menu_list[menu_sel].value);
			func( FUNC_CHANGE_VALUE , direction );
			break;
		case TMENU_FUNCTION_EXIT:
			func = (void *)menu_list[menu_sel].value;
			func();
			return 2;
			break;	
		case TMENU_EXIT:
			return 1;
			break;
		case TMENU_SWITCH:
			*(int *)menu_list[menu_sel].value = ( *(int *)menu_list[menu_sel].value )? 0:1;
			break;
		}
	}
	return 0; // continue
}

